View Issue Details

IDProjectCategoryView StatusLast Update
0033689FPCPackagespublic2018-05-09 11:11
ReporterStephanoAssigned ToMichael Van Canneyt 
PrioritynormalSeverityminorReproducibilityhave not tried
Status closedResolutionfixed 
Product Version3.1.1Product Build 
Target Version3.2.0Fixed in Version3.1.1 
Summary0033689: fpreport: Report with empty Page.Data causes a SIGSEGV
Description- Load the attached report
- Preview
Preview is ok
- Change Page1.Data to blank
- Preview
SIGSEGV

The exception seems to be related to the presence of aggregate variables.
Why is Page.Data needed anyway?
TagsNo tags attached.
Fixed in Revision38906
FPCOldBugId0
FPCTarget
Attached Files

Activities

Stephano

2018-05-04 08:35

developer  

EmployeeAggregates.json (27,617 bytes)

Michael Van Canneyt

2018-05-05 14:04

administrator   ~0108148

I have re-interpreted Page.Data :

Per report page, the engine will now determine the main data loop.
This is the first data band's data loop, if the data band has no master.
This will be used to render the bands on a page.
(the logic for subdetails remains unchanged)

This means page data no longer needs to be set: Page.Data can be Nil.

But, if it is set, and it is different from the main data loop on the page,
the page (and any loops on it) is rendered for each record in the page.data loop.

If the main data loop equals the page data loop, the logic is as if the Page.Data is nil (for backwards compatibility)

Michael Van Canneyt

2018-05-05 14:16

administrator  

pagedatademo.json (30,561 bytes)

Michael Van Canneyt

2018-05-05 14:17

administrator   ~0108149

Attached a demo.

Note that the report title/summary are printed each time a page is rendered, this is as designed (and compatible to FastReport)

Stephano

2018-05-09 11:11

developer   ~0108209

The SIGSEGV is no more, but other bugs popped up. I will open corresponding bug reports.
Also better not allow Page.Data to be the same as the master data band data, even in the name of backward compatibility. Let the designer popup an error.

Issue History

Date Modified Username Field Change
2018-05-04 08:35 Stephano New Issue
2018-05-04 08:35 Stephano Status new => assigned
2018-05-04 08:35 Stephano Assigned To => Michael Van Canneyt
2018-05-04 08:35 Stephano File Added: EmployeeAggregates.json
2018-05-05 14:04 Michael Van Canneyt Fixed in Revision => 38906
2018-05-05 14:04 Michael Van Canneyt Note Added: 0108148
2018-05-05 14:04 Michael Van Canneyt Status assigned => resolved
2018-05-05 14:04 Michael Van Canneyt Fixed in Version => 3.1.1
2018-05-05 14:04 Michael Van Canneyt Resolution open => fixed
2018-05-05 14:04 Michael Van Canneyt Target Version => 3.2.0
2018-05-05 14:16 Michael Van Canneyt File Added: pagedatademo.json
2018-05-05 14:17 Michael Van Canneyt Note Added: 0108149
2018-05-09 11:11 Stephano Note Added: 0108209
2018-05-09 11:11 Stephano Status resolved => closed